// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from micro_ros_diagnostic_msgs:srv/MicroROSSelfTest.idl
// generated code does not contain a copyright notice

#ifndef MICRO_ROS_DIAGNOSTIC_MSGS__SRV__DETAIL__MICRO_ROS_SELF_TEST__STRUCT_HPP_
#define MICRO_ROS_DIAGNOSTIC_MSGS__SRV__DETAIL__MICRO_ROS_SELF_TEST__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request __attribute__((deprecated))
#else
# define DEPRECATED__micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request __declspec(deprecated)
#endif

namespace micro_ros_diagnostic_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct MicroROSSelfTest_Request_
{
  using Type = MicroROSSelfTest_Request_<ContainerAllocator>;

  explicit MicroROSSelfTest_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  explicit MicroROSSelfTest_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  // field types and members
  using _structure_needs_at_least_one_member_type =
    uint8_t;
  _structure_needs_at_least_one_member_type structure_needs_at_least_one_member;


  // constant declarations

  // pointer types
  using RawPtr =
    micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request
    std::shared_ptr<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request
    std::shared_ptr<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MicroROSSelfTest_Request_ & other) const
  {
    if (this->structure_needs_at_least_one_member != other.structure_needs_at_least_one_member) {
      return false;
    }
    return true;
  }
  bool operator!=(const MicroROSSelfTest_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MicroROSSelfTest_Request_

// alias to use template instance with default allocator
using MicroROSSelfTest_Request =
  micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace micro_ros_diagnostic_msgs


// Include directives for member types
// Member 'status'
#include "micro_ros_diagnostic_msgs/msg/detail/micro_ros_diagnostic_status__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response __attribute__((deprecated))
#else
# define DEPRECATED__micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response __declspec(deprecated)
#endif

namespace micro_ros_diagnostic_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct MicroROSSelfTest_Response_
{
  using Type = MicroROSSelfTest_Response_<ContainerAllocator>;

  explicit MicroROSSelfTest_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : status(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = "";
      this->passed = 0;
    }
  }

  explicit MicroROSSelfTest_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : id(_alloc),
    status(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = "";
      this->passed = 0;
    }
  }

  // field types and members
  using _id_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _id_type id;
  using _passed_type =
    unsigned char;
  _passed_type passed;
  using _status_type =
    micro_ros_diagnostic_msgs::msg::MicroROSDiagnosticStatus_<ContainerAllocator>;
  _status_type status;

  // setters for named parameter idiom
  Type & set__id(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__passed(
    const unsigned char & _arg)
  {
    this->passed = _arg;
    return *this;
  }
  Type & set__status(
    const micro_ros_diagnostic_msgs::msg::MicroROSDiagnosticStatus_<ContainerAllocator> & _arg)
  {
    this->status = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response
    std::shared_ptr<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response
    std::shared_ptr<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MicroROSSelfTest_Response_ & other) const
  {
    if (this->id != other.id) {
      return false;
    }
    if (this->passed != other.passed) {
      return false;
    }
    if (this->status != other.status) {
      return false;
    }
    return true;
  }
  bool operator!=(const MicroROSSelfTest_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MicroROSSelfTest_Response_

// alias to use template instance with default allocator
using MicroROSSelfTest_Response =
  micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace micro_ros_diagnostic_msgs


// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Event __attribute__((deprecated))
#else
# define DEPRECATED__micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Event __declspec(deprecated)
#endif

namespace micro_ros_diagnostic_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct MicroROSSelfTest_Event_
{
  using Type = MicroROSSelfTest_Event_<ContainerAllocator>;

  explicit MicroROSSelfTest_Event_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_init)
  {
    (void)_init;
  }

  explicit MicroROSSelfTest_Event_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _info_type =
    service_msgs::msg::ServiceEventInfo_<ContainerAllocator>;
  _info_type info;
  using _request_type =
    rosidl_runtime_cpp::BoundedVector<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request_<ContainerAllocator>>>;
  _request_type request;
  using _response_type =
    rosidl_runtime_cpp::BoundedVector<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response_<ContainerAllocator>>>;
  _response_type response;

  // setters for named parameter idiom
  Type & set__info(
    const service_msgs::msg::ServiceEventInfo_<ContainerAllocator> & _arg)
  {
    this->info = _arg;
    return *this;
  }
  Type & set__request(
    const rosidl_runtime_cpp::BoundedVector<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request_<ContainerAllocator>>> & _arg)
  {
    this->request = _arg;
    return *this;
  }
  Type & set__response(
    const rosidl_runtime_cpp::BoundedVector<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response_<ContainerAllocator>>> & _arg)
  {
    this->response = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Event_<ContainerAllocator> *;
  using ConstRawPtr =
    const micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Event_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Event_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Event_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Event_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Event_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Event_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Event_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Event_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Event_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Event
    std::shared_ptr<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Event_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Event
    std::shared_ptr<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Event_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MicroROSSelfTest_Event_ & other) const
  {
    if (this->info != other.info) {
      return false;
    }
    if (this->request != other.request) {
      return false;
    }
    if (this->response != other.response) {
      return false;
    }
    return true;
  }
  bool operator!=(const MicroROSSelfTest_Event_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MicroROSSelfTest_Event_

// alias to use template instance with default allocator
using MicroROSSelfTest_Event =
  micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Event_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace micro_ros_diagnostic_msgs

namespace micro_ros_diagnostic_msgs
{

namespace srv
{

struct MicroROSSelfTest
{
  using Request = micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request;
  using Response = micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response;
  using Event = micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Event;
};

}  // namespace srv

}  // namespace micro_ros_diagnostic_msgs

#endif  // MICRO_ROS_DIAGNOSTIC_MSGS__SRV__DETAIL__MICRO_ROS_SELF_TEST__STRUCT_HPP_
